"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HoverHighlighter = void 0;
const react_1 = __importStar(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const use_debounce_1 = require("use-debounce");
const react_modules_dom_to_react_1 = require("@teambit/react.modules.dom-to-react");
const react_ui_hover_selector_1 = require("@teambit/react.ui.hover-selector");
const bit_react_component_1 = require("../bit-react-component");
const hover_highlighter_module_scss_1 = __importDefault(require("./hover-highlighter.module.scss"));
const ignore_highlighter_1 = require("../../ignore-highlighter");
const element_highlighter_1 = require("../../element-highlighter");
/** automatically highlight components on hover */
function HoverHighlighter(_a) {
    var { children, disabled, classes, highlightStyle, placement } = _a, rest = __rest(_a, ["children", "disabled", "classes", "highlightStyle", "placement"]);
    const [target, setTarget] = (0, react_1.useState)();
    const _handleElement = (0, react_1.useCallback)((element) => {
        // clear highlighter at the edges:
        if (!element || element.hasAttribute('data-nullify-component-highlight')) {
            setTarget(undefined);
            return;
        }
        // skip DOM trees having 'data-ignore-component-highlight'
        if (element.closest(ignore_highlighter_1.excludeHighlighterSelector))
            return;
        const result = bubbleToBitComponent(element);
        if (!result)
            return;
        setTarget({
            element: result.element,
            id: result.meta.id,
            scopeLink: undefined,
            link: result.meta.homepage,
            local: result.meta.exported === false,
        });
    }, []);
    const handleElement = (0, use_debounce_1.useDebouncedCallback)(_handleElement, target ? 80 : 0);
    // clear target when disabled
    (0, react_1.useEffect)(() => {
        if (disabled) {
            setTarget(undefined);
        }
    }, [disabled]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_ui_hover_selector_1.HoverSelector, Object.assign({}, rest, { className: (0, classnames_1.default)(hover_highlighter_module_scss_1.default.highlighter, !disabled && hover_highlighter_module_scss_1.default.active), onElementChange: handleElement, disabled: disabled, "data-nullify-component-highlight": true }), children),
        target && react_1.default.createElement(element_highlighter_1.ElementHighlighter, { target: target, classes: classes, style: highlightStyle, placement: placement })));
}
exports.HoverHighlighter = HoverHighlighter;
/** go up the dom tree until reaching a react bit component */
function bubbleToBitComponent(element, filter) {
    for (let current = element; current; current = current.parentElement) {
        current = (0, react_modules_dom_to_react_1.toRootElement)(current);
        if (!current || (filter === null || filter === void 0 ? void 0 : filter(current)) === false)
            return undefined;
        const component = (0, react_modules_dom_to_react_1.domToReact)(current);
        if ((0, bit_react_component_1.hasComponentMeta)(component)) {
            const meta = component.__bit_component;
            return {
                element: current,
                component,
                meta,
            };
        }
    }
    return undefined;
}
//# sourceMappingURL=hover-highlighter.js.map