import React from 'react';
import { Placement } from '../label';
export interface ElementHighlighterProps extends React.HTMLAttributes<HTMLDivElement> {
    /** target element to highlight */
    target: HighlightTarget;
    /** default location of the label */
    placement?: Placement;
    /** customize styles */
    classes?: HighlightClasses;
}
export { Placement };
export declare type HighlightTarget = {
    id?: string;
    element: HTMLElement;
    /** e.g. 'https://bit.dev/teambit/base-ui/elements/dots-loader', */
    link?: string;
    /** e.g. 'https://bit.dev/teambit/base-ui' */
    scopeLink?: string;
    /** use full production url, or local workspace url */
    local?: boolean;
};
export declare type HighlightClasses = {
    container?: string;
    frame?: string;
    label?: string;
};
export declare function ElementHighlighter({ target, placement, className, classes, ...props }: ElementHighlighterProps): JSX.Element;
